# Ansible Playbook  2.9
# Upgrade with rsync

---
- name: Get the username running the deploy
  become: false
  delegate_to: localhost
  command: whoami
  register: username
  tags:
    - replica-upgrade
    - get-tmp-owner

- debug: var=username.stdout verbosity=3

- name: Change data directories owners
  become: true
  become_user: root
  file:
    path: "{{ upper_datadir }}"
    state: directory
    recurse: true
    owner: "{{ username.stdout }}"
    group: "{{ username.stdout }}"
  tags:
    - replica-upgrade
    - change-owner

- name: Verify whether PostgreSQL is stopped
  ignore_errors: true
  shell: pgrep -lx postgres
  register: pids_of_postgres
  tags:
    - replica-upgrade
    - postgres-run

- name: Upgrade Replica using RSync
  become: false
  delegate_to: "{{ groups.primary[0] }}"
  shell: >
    rsync -e "ssh -o StrictHostKeyChecking=no" --archive --delete --hard-links --size-only --no-inc-recursive
    {{ relative_old_datadir }} {{ relative_new_datadir }} {{ item }}:{{ upper_datadir }}
  args:
    executable: /bin/bash
    chdir: /var/opt/gitlab/postgresql
  run_once: true
  loop: "{{ groups.secondary|list }}"
  when: pids_of_postgres.rc != 0
  register: synced
  tags:
    - replica-upgrade
    - rsync-pg

- name: Restore data directories owners
  become: true
  become_user: root
  file:
    path: "{{ upper_datadir }}"
    state: directory
    recurse: true
    owner: "{{ datadir_owner }}"
    group: "{{ datadir_owner }}"
  tags:
    - replica-upgrade
    - restore-owner
